import { EntityEquippableComponent, EquipmentSlot, system, world } from "@minecraft/server";

world.afterEvents.entityHurt.subscribe((v) => {
    if (v.damageSource.damagingEntity) {
        let item = v.damageSource.damagingEntity.getComponent(EntityEquippableComponent.componentId).getEquipment(EquipmentSlot.Mainhand);
        if (item && item.type.id == "roserosegold:rose_gold_sword") {
            v.damageSource.damagingEntity.runCommandAsync("effect @s regeneration 5");
        };
    };
});

system.runInterval(() => {
    for (let player of world.getPlayers()) {
        let roseGoldCounter = 0;
        let head = player.getComponent(EntityEquippableComponent.componentId).getEquipment(EquipmentSlot.Head);
        if (head && head.type.id == "roserosegold:rose_gold_helmet") roseGoldCounter++;
        let chest = player.getComponent(EntityEquippableComponent.componentId).getEquipment(EquipmentSlot.Chest);
        if (chest && chest.type.id == "roserosegold:rose_gold_chestplate") roseGoldCounter++;
        let legs = player.getComponent(EntityEquippableComponent.componentId).getEquipment(EquipmentSlot.Legs);
        if (legs && legs.type.id == "roserosegold:rose_gold_leggings") roseGoldCounter++;
        let feet = player.getComponent(EntityEquippableComponent.componentId).getEquipment(EquipmentSlot.Feet);
        if (feet && feet.type.id == "roserosegold:rose_gold_boots") roseGoldCounter++;
        if (roseGoldCounter > 0) player.runCommandAsync(`effect @s health_boost 5 ${roseGoldCounter == 4 ? 4 : roseGoldCounter - 1} true`)
    };
})